//--------------------------------------------------------------------------------
// Project LibPhylo
//
// Copyright (C) 2000 Andreas Heger All rights reserved
//
// Author: Andreas Heger <heger@ebi.ac.uk>
//
// $Id: HelpersMatrix.h,v 1.1.1.1 2002/07/08 21:20:17 heger Exp $
//--------------------------------------------------------------------------------


#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef HELPERS_MATRIX_H
#define HELPERS_MATRIX_H 1

#include <iosfwd>
#include "phylolib.h"

namespace PhyloLib {

    class Matrix;

    /** Helper functions for class Alignata:
	
	1. factory functions
	
	2. accessor functions for default objects
	
	3. convenience functions
    */
    
    /* -------------------------------------------------------------------------------------------------------------------- */
    /* 1. factory functions */

    /** create an empty symmetric matrix */
    Matrix * makeMatrixSymmetric( TYPE_MATRIX_SIZE size = 0, TYPE_MATRIX_VALUE default_value = 0);

    /* -------------------------------------------------------------------------------------------------------------------- */
    /* 2. accessor functions for default objects */
    
    /* -------------------------------------------------------------------------------------------------------------------- */
    /* 3. convenience functions */
    
    /** fill matrix with values from source */
    Matrix * fillMatrix( Matrix * dest, TYPE_MATRIX_VALUE * source );

}

#endif	/* HELPERS_MATRIX_H */
