//--------------------------------------------------------------------------------
// Project LibAlign
//
// Copyright (C) 2000 Andreas Heger All rights reserved
//
// Author: Andreas Heger <heger@ebi.ac.uk>
//
// $Id: ImplDistor.cpp,v 1.1.1.1 2002/07/08 21:20:17 heger Exp $
//--------------------------------------------------------------------------------    


#include <iostream>
#include <iomanip>

#include <alignlib/MultipleAlignment.h>

#include "phylolib.h"
#include "ImplDistor.h"
#include "PhyloException.h"
#include "Matrix.h"

using namespace std;

namespace PhyloLib {

//---------------------------------------------------------< constructors and destructors >--------------------------------------
ImplDistor::ImplDistor () : mLength(0) {
}
		       
ImplDistor::~ImplDistor () {
}

ImplDistor::ImplDistor (const ImplDistor & src ) : 
    mLength(src.mLength) {
}

//--------------------------------------------------------------------------------------------------------------------------------
Matrix * ImplDistor::calculateMatrix( Matrix * matrix, const AlignLib::MultipleAlignment * multali) const {

    TYPE_MATRIX_SIZE i, j;
    
    TYPE_MATRIX_SIZE width = multali->getWidth();

    if (matrix->getWidth() != width)
	throw PhyloException( "Multiple alignment and matrix have different size in ImplDistor::operator()");

    for (i = 0; i < width - 1; i++) 
      for (j = i + 1; j < width; j++) 
	(*matrix)(i, j) = calculateDistance( (*multali)[i], (*multali)[j] );

    return matrix;
} 
    

//--------------------------------------------------------------------------------------------------------------------------------

} // namespace PhyloLib
