//--------------------------------------------------------------------------------
// Project LibAlign
//
// Copyright (C) 2000 Andreas Heger All rights reserved
//
// Author: Andreas Heger <heger@ebi.ac.uk>
//
// $Id: ImplMatrixSymmetric.h,v 1.1.1.1 2002/07/08 21:20:17 heger Exp $
//--------------------------------------------------------------------------------

#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef IMPL_MATRIX_SYMMETRIC_H
#define IMPL_MATRIX_SYMMETRIC_H 1

#include <iosfwd>

#include "ImplMatrix.h"

namespace PhyloLib {

/**

   @author Andreas Heger
   @version $Id: ImplMatrixSymmetric.h,v 1.1.1.1 2002/07/08 21:20:17 heger Exp $
   @short contains a matrix
*/ 

class ImplMatrixSymmetric : public ImplMatrix {
 public:
  
  /* constructors and desctructors------------------------------------------------------- */

  /** empty constructor */
  ImplMatrixSymmetric ();

  /** create matrix of width and set all values to default_value */
  ImplMatrixSymmetric( TYPE_MATRIX_SIZE width, TYPE_MATRIX_VALUE default_value);

  /** load array */
  ImplMatrixSymmetric( TYPE_MATRIX_SIZE width, TYPE_MATRIX_VALUE * source);

  /** copy constructor */
  ImplMatrixSymmetric (const ImplMatrixSymmetric &);

  /** destructor */
  virtual ~ImplMatrixSymmetric ();

  /* member access functions--------------------------------------------------------------- */

  /** delete last row/column from matrix */
  virtual void Shrink();

  /** swap two columns/rows */
  virtual void Swap( TYPE_MATRIX_SIZE col_1, TYPE_MATRIX_SIZE col_2 );

 protected:
  
  /** get row for given index */
  virtual TYPE_MATRIX_SIZE getRow( TYPE_MATRIX_SIZE index ) const;
 
  /** get column for given index */
  virtual TYPE_MATRIX_SIZE getColumn( TYPE_MATRIX_SIZE index ) const;
 
  /** return mapped index for row and column */
  virtual TYPE_MATRIX_SIZE getIndex(TYPE_MATRIX_SIZE row, TYPE_MATRIX_SIZE col) const;   

  /** calculate the size of the matrix */
  virtual void calculateSize();

};


}

#endif /* _ALIGNATUMSEQUENCE_H */

