//--------------------------------------------------------------------------------
// Project LibAlign
//
// Copyright (C) 2000 Andreas Heger All rights reserved
//
// Author: Andreas Heger <heger@ebi.ac.uk>
//
// $Id: phylolib.h,v 1.1.1.1 2002/07/08 21:20:17 heger Exp $
//--------------------------------------------------------------------------------

/** 
    some global defines
    define
	DEBUG, if debugging should be turned on
*/


#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef PHYLOLIB_H
#define PHYLOLIB_H 1

namespace PhyloLib {

/* Loglevel:
   LL0:	silent
   LL1:
   LL2:	+important intermediate results, for example sequence weights, ...
   LL3:	+trace
   LL4:	+debugging with intermediate results
*/

#ifdef DEBUG
typedef enum { LL0, LL1, LL2, LL3, LL4, LL5 } LOGLEVEL;
 static LOGLEVEL verbose = LL4;					// i.e. LL3
#endif 


  enum LINKAGE_METHOD {
      SINGLE_LINKAGE,		
      COMPLETE_LINKAGE,
      AVERAGE_LINKAGE,		// = UPGMA
      UPGMA,			// = unweighted pair group method average (UPGMA), see Theodoridis & Koutroumbas, p411
      WPGMA,			// = weighted pair group method average (WPGMA), as above
      UPGMC,			// = unweighted pair group method centroid (UPGMC), as above
      WPGMC			// = weighted pair group method centroid (UPGMC), as above
  };

 /* type of a height of a node in the tree */
 typedef double TYPE_HEIGHT;

 /* type of a weight of an edge in the tree */
 typedef double TYPE_WEIGHT;

 /* type of a node */
 typedef unsigned long TYPE_NODE;


 struct COORD { 
   unsigned long row;
   unsigned long col;
 };

 typedef double TYPE_MATRIX_VALUE;

 typedef unsigned long TYPE_MATRIX_SIZE;

}

#endif /* PHYLOLIB_H */
