//--------------------------------------------------------------------------------
// Project LibAlign
//
// Copyright (C) 2000 Andreas Heger All rights reserved
//
// Author: Andreas Heger <heger@ebi.ac.uk>
//
// $Id: test_Distor.cpp,v 1.2 2004/06/02 12:14:35 aheger Exp $
//--------------------------------------------------------------------------------

/** Test Matrix object
*/

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>

#include <time.h> 

#include <alignlib/MultipleAlignment.h>
#include <alignlib/HelpersMultipleAlignment.h>
#include <alignlib/HelpersAlignatum.h>

#include "phylolib.h"
#include "Matrix.h"
#include "HelpersMatrix.h"
#include "Distor.h"
#include "HelpersDistor.h"

using namespace std;

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

using namespace PhyloLib;

int main () {
  
  // create a multiple alignment
  AlignLib::MultipleAlignment * mali = AlignLib::makeMultipleAlignment();
  mali->Add(AlignLib::makeAlignatumFromString("-AADDAACCAAA-"));
  mali->Add(AlignLib::makeAlignatumFromString("AAKKAA-CCAAAA"));
  mali->Add(AlignLib::makeAlignatumFromString("-A-AAA-CCA-A-"));
  mali->Add(AlignLib::makeAlignatumFromString("AAAGAAA--AAAA"));     

  Matrix * matrix = makeMatrixSymmetric(4, 0);

  cout << *matrix << endl;

  Distor * d1 = makeDistorKimura();
  d1->calculateMatrix( matrix, mali );
  cout << *matrix << endl;

  Distor * d2 = makeDistorClustal();
  d2->calculateMatrix( matrix, mali );
  cout << *matrix << endl;

  delete d1;
  delete d2;
  delete matrix;
  delete mali;

  return (EXIT_SUCCESS);

}
